#include "functions.h"



LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void InitCommonControlsEx();

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
	WNDCLASSEX wc; 
	HWND hwnd; 
	MSG Msg; 
	
     char Path[MAX_PATH];
     
     GetModuleFileName(NULL, Path, MAX_PATH);
     getDrivePath=Path;
     int truncate_path = getDrivePath.find_last_of("\\");
     getDrivePath.erase(truncate_path+1);   /* Retain full pathway  */	

     cauismia=getDrivePath;       
     cauismia+="missing.cau";	

	memset(&wc,0,sizeof(wc));
	wc.cbSize		 = sizeof(WNDCLASSEX);
	wc.lpfnWndProc	 = WndProc; 
	wc.hInstance	 = hInstance;
	wc.hCursor		 = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
	wc.lpszClassName = "Windows Class";
	wc.hIcon		 = LoadIcon(NULL, IDI_APPLICATION); 
	wc.hIconSm		 = LoadIcon(NULL, IDI_APPLICATION); 

	if(!RegisterClassEx(&wc)) {
		MessageBox(NULL, "Window Registration Failed!","Error!",MB_ICONEXCLAMATION|MB_OK);
		return 0;
	}

    short Left=GetSystemMetrics(SM_CXSCREEN)/2;
    short Top=GetSystemMetrics(SM_CYSCREEN)/2;        
    
	hwnd = CreateWindowEx(WS_EX_CLIENTEDGE,"Windows Class","Tpa_Generator",WS_VISIBLE|WS_OVERLAPPEDWINDOW,
		Left-200, 
		Top-180,
		440, 
		420, 
		NULL,NULL,hInstance,NULL);
		
    ShowWindow (hwnd, nCmdShow);
    
    hNewCaptions = CreateWindowEx(WS_EX_CLIENTEDGE, TEXT("EDIT"), TEXT(""),
    WS_CHILD | WS_VISIBLE |ES_MULTILINE| WS_VSCROLL |ES_AUTOVSCROLL,
    22, 260, 375, 80, hwnd,
    (HMENU) IDE_NEWCAPS, GetModuleHandle(NULL), NULL);
    

    SendMessage(hNewCaptions, WM_SETFONT, (WPARAM) GetStockObject(DEFAULT_GUI_FONT),
    true);    
    
	hUserInfo=CreateWindowEx(0, TEXT("STATIC"), TEXT(""),   
	WS_VISIBLE | WS_CHILD | SS_BITMAP, 6,8,407,246,
	hwnd,(HMENU) IDS_USERS,GetModuleHandle(NULL),NULL);  
	
      HDC hDC=NULL, hDC_player=NULL;
       HBITMAP p_player;
       int nWidth, nHeight;	

    //Skin static control for information usage
       p_player = reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle (NULL),
       MAKEINTRESOURCE(IDI_INFO),
       IMAGE_BITMAP,0,0,
       LR_CREATEDIBSECTION));
       
       SendMessage(hUserInfo,(UINT)STM_SETIMAGE,
       (WPARAM)IMAGE_BITMAP,(LPARAM)p_player);
       
       HDC memDC_ply = CreateCompatibleDC ( hDC_player );
       p_player = CreateCompatibleBitmap (hDC_player, nWidth, nHeight);
       
       SelectObject ( memDC_ply, p_player ); 
       DeleteDC(memDC_ply);
       DeleteObject(p_player);		  

	if(hwnd == NULL) {
		MessageBox(NULL, "Window Creation Failed!","Error!",MB_ICONEXCLAMATION|MB_OK);
		return 0;
	}

	while(GetMessage(&Msg, NULL, 0, 0) > 0) { 
		TranslateMessage(&Msg); 
		DispatchMessage(&Msg); 
	}
	return Msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam) {
	switch(Message) {
		
		case WM_CREATE:
		 {
		  AppendMenu(hMenuBar, MF_POPUP, (UINT_PTR) hFile, "File");   
	      AppendMenu(hFile, MF_STRING, MU_LOADDIR, "SELECT_DIR (LOCATION OF CAU FILES)");
	      
	      AppendMenu(hMenuBar, MF_POPUP, (UINT_PTR) hConvert, "Convert");
	      AppendMenu(hConvert, MF_STRING, MU_BATCHER, "*Dir_to_Caus");
	      AppendMenu(hConvert, MF_STRING, MU_CONVERT, "*wav_to_cau");
		  	
	      SetMenu(hwnd, hMenuBar); 
		  break;
		 }		
		
		
		case WM_DESTROY: {
			PostQuitMessage(0);
			break;
		}
		
        case WM_COMMAND:
            {
            	
          switch(LOWORD(wParam))
           { 
         
case MU_CONVERT:
	 {
	 	    edline1=0;
            edline1 = GetWindowTextLength(GetDlgItem(hwnd,IDE_NEWCAPS));
            
            if(edline1 > 0) 
              {
                linea_buf = (char*)GlobalAlloc(GPTR, edline1 + 1);
                GetDlgItemText(hwnd, IDE_NEWCAPS, linea_buf, edline1 + 1);	 
			}
     Export_Cau();
      if(abortcau==1) {
     SendMessage(hNewCaptions, WM_SETTEXT,0,0);	
	 MessageBeep(0x00000040L);
	 SetDlgItemText(hwnd,IDE_NEWCAPS,"Cau export complete . .. "); 
       }
        else {
        	     SendMessage(hNewCaptions, WM_SETTEXT,0,0);	
	             MessageBeep(0x00000040L);
	             SetDlgItemText(hwnd,IDE_NEWCAPS,"User Canceled . .. No file selected.");
        }
	  }	
	 break;
	 
case MU_BATCHER:
  {
        wavfolder=0;
        OPENFILENAME ofn;
        char szWavFolder[MAX_PATH] = "";
        ZeroMemory(&ofn, sizeof(ofn));
        ofn.lStructSize = sizeof(ofn); 
        ofn.hwndOwner = hwnd;
        ofn.lpstrFilter = "Wav File (*.wav)\0*.wav\0";
        ofn.lpstrFile = szWavFolder;
        ofn.nMaxFile = MAX_PATH;
        ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY
        |OFN_PATHMUSTEXIST;
        ofn.lpstrDefExt = "";
                
        if(GetOpenFileName(&ofn))
         {  
         
           wavfolder=1; 
           std::string chopwav;
           std::string wavpaths=szWavFolder;
           int nullname = wavpaths.rfind("\\");
           wavpaths.erase(nullname);
           wavpaths+="\\";
           
           std::string exttype = "*wav"; // look only for this file type
           std::string opnthisLoc2 = wavpaths + exttype;   

          WIN32_FIND_DATA file;
           HANDLE hFind;

   hFind=FindFirstFile(opnthisLoc2.c_str(), &file);  
             org_wavPath=wavpaths;
             org_wavPath+=file.cFileName;
                         
             new_caupath+=wavpaths;
             new_caupath=file.cFileName;
             new_caupath.erase(new_caupath.length()-3, 3);
             new_caupath+="cau";
             Export_Batch();
             org_wavPath.erase();
             new_caupath.erase();       
          
        while (FindNextFile(hFind, &file)>0) 
           {            
             org_wavPath=wavpaths;
             org_wavPath+=file.cFileName;
                         
             new_caupath+=wavpaths;
             new_caupath=file.cFileName;
             new_caupath.erase(new_caupath.length()-3, 3);
             new_caupath+="cau";
             Export_Batch();
             org_wavPath.erase();
             new_caupath.erase();            
           }

             FindClose(hFind);
          } //user chose a wav, process folder contents within this loop
          
             if(wavfolder==0) {
 			  MessageBox(NULL, "Operation canceled by user . . .", "Tpa_Generator", MB_ICONASTERISK);	
        	 }
        	 
        	 if(wavfolder==1 && tpafail==0) {
			  MessageBox(NULL, "Files are Done!", "Tpa_Generator", MB_ICONASTERISK);		
        	 } 
        }
        break;           
           
        case MU_LOADDIR:
        	{
           choose_dir();
            if(caufolder==1) {
              choose_tpa();	
            }
               else {
                 SendMessage(hNewCaptions, WM_SETTEXT,0,0);	
	             MessageBeep(0x00000040L);
	             SetDlgItemText(hwnd,IDE_NEWCAPS,"Directory load canceled . . .");
               }
               
            if(tpawriteok==1 )
             {
              caus_to_tpa();
            }
            if(tpafail==0 && tpawriteok==1) {
              MessageBox(NULL, "File Done!", "Tpa_Generator", MB_ICONASTERISK);		  	
             }
                else {
                 MessageBox(NULL, "tpa build was canceled . . .", "Tpa_Generator", MB_ICONASTERISK);
               }
               
          }
		   break;   
		   
	}
  }
		
		/* All other messages (a lot of them) are processed using default procedures */
		default:
			return DefWindowProc(hwnd, Message, wParam, lParam);
	}
	return 0;
}
